create table stop_route(
	Stop varchar(32),
	Route varchar(32),
	Position int,
	primary key(Stop,Route)
)
go
delete from stop_route

insert into stop_route (Stop,Route,Position) values ('S1','R1',1)
insert into stop_route (Stop,Route,Position) values ('S2','R1',2)
insert into stop_route (Stop,Route,Position) values ('S3','R1',3)
insert into stop_route (Stop,Route,Position) values ('S4','R1',4)
insert into stop_route (Stop,Route,Position) values ('S5','R1',5)


insert into stop_route (Stop,Route,Position) values ('S6','R2',1)
insert into stop_route (Stop,Route,Position) values ('S7','R2',2)
insert into stop_route (Stop,Route,Position) values ('S2','R2',3)
insert into stop_route (Stop,Route,Position) values ('S8','R2',4)

insert into stop_route (Stop,Route,Position) values ('S8','R3',1)
insert into stop_route (Stop,Route,Position) values ('S9','R3',2)
insert into stop_route (Stop,Route,Position) values ('S10','R3',3)
go
create proc InquiryT0(@StartStop varchar(32),@EndStop varchar(32))
as
begin
	select 
		sr1.Stop as ʼվ,
		sr2.Stop as Ŀվ,
		sr1.Route as ·,
		sr2.Position-sr1.Position as վ
	from 
		stop_route sr1,
		stop_route sr2
	where 
		sr1.Route=sr2.Route 
		and sr1.Position<sr2.Position 
		and sr1.Stop=@StartStop 
		and sr2.Stop=@EndStop
end
go
create view RouteT0
as
	select 
		sr1.Stop as StartStop,	--ʼվ
		sr2.Stop as EndStop,	--Ŀվ
		sr1.Route as Route,		--·
		sr2.Position-sr1.Position as StopCount	--վ
	from
		stop_route sr1,
		stop_route sr2
	where 
		sr1.Route=sr2.Route 
		and sr1.Position<sr2.Position 
go
create proc InquiryT1(@StartStop varchar(32),@EndStop varchar(32))
as
begin
	select
		r1.StartStop as ʼվ,
		r1.Route as ·1,
		r1.EndStop as תվ1,
		r2.Route as ·2,
		r2.EndStop as Ŀվ,
		r1.StopCount+r2.StopCount as վ
	from 
		RouteT0 r1,
		RouteT0 r2
	where
		r1.StartStop=@StartStop
		and r1.EndStop=r2.StartStop
		and r2.EndStop=@EndStop
end
go
create proc InquiryT2(@StartStop varchar(32),@EndStop varchar(32))
as
begin
	select
		r1.StartStop as ʼվ,
		r1.Route as ·1,
		r1.EndStop as תվ1,
		r2.Route as ·2,
		r2.EndStop as תվ2,
		r3.Route as ·3,
		r3.EndStop as Ŀվ,
		r1.StopCount+r2.StopCount+r3.StopCount as վ
	from 
		RouteT0 r1,
		RouteT0 r2,
		RouteT0 r3
	where
		r1.StartStop=@StartStop
		and r1.EndStop=r2.StartStop
		and r2.EndStop=r3.StartStop
		and r3.EndStop=@EndStop
end